#define LAMP 9  // relee out
#define ANDUR 10  // pir in
#define ANDUR_A A0 // analog
#define SWITCH 4  // sw in
#define LED_1 5  // led out
#define LED_2 6  // led out
#define LED_3 7  // led out
#define LED_4 8  // led out
#define LED_NET 13 	/// serial LED

#define V2LJAS  0
#define SEES  1

int dly = 1000;
int lugem = 0;
int idle = 0;
int seisund = V2LJAS;
int internetiSeisund = V2LJAS;
int dlyTime = 0;
int ls = LOW;

String inputString = "";         // a string to hold incoming data
//boolean stringComplete = false;  // whether the string is complete

void setup() {
  Serial.begin(9600);
  
  pinMode(LAMP, OUTPUT);
  pinMode(ANDUR, INPUT);
  pinMode(SWITCH, INPUT);
  pinMode(LED_1, OUTPUT);
  pinMode(LED_2, OUTPUT);
  pinMode(LED_3, OUTPUT);
  pinMode(LED_4, OUTPUT);
  pinMode(LED_NET, OUTPUT);
  
  inputString.reserve(200);
  
  digitalWrite(LAMP, LOW);
}

void loop() {    
  if(digitalRead(SWITCH) == HIGH){
    seisund = V2LJAS;
    delay(100);
    seisund = SEES;
    lugem = 0;
    idle = 0;
    endBin();
  }else{
    seisund = V2LJAS;
  }
  
  if(internetiSeisund == SEES) {
    if(seisund == SEES){
      digitalWrite(LAMP, HIGH);
    }else if(seisund == V2LJAS){
      if(idle >= 5){
        digitalWrite(LAMP, LOW);
        lugem = 0;
        idle = 0;
        endBin();
      }
      
      ls = digitalRead(ANDUR);
      
      if (ls == HIGH){
        lugem++;
        digitalWrite(LAMP, HIGH);
        //delay(dly * (2 ^ (lugem - 1)));
        delay(1000);
        showBin((lugem - 1));
      }else{
        idle++;
        delay(1000);
      }
    }
  }else if(internetiSeisund == V2LJAS){
    digitalWrite(LAMP, LOW);
  }
}

void showBin(int lugem){
  if(lugem % 2 == 0){
    digitalWrite(LED_4, HIGH);
  }else{
    digitalWrite(LED_4, LOW);
  }
  
  if(lugem % 4 == 1 || lugem % 4 == 2){
    digitalWrite(LED_3, HIGH);
  }else{
    digitalWrite(LED_3, LOW);
  }
  
  if(lugem % 8 == 3 || lugem % 8 == 4 || lugem % 8 == 5 || lugem % 8 == 6)
  {
    digitalWrite(LED_2, HIGH);
  }else{
    digitalWrite(LED_2, LOW);
  }
  
  if(lugem % 16 == 7 || lugem % 16 == 8 || lugem % 16 == 9 || lugem % 16 == 10
     || lugem % 16 == 11 || lugem % 16 == 12 || lugem % 16 == 13 || lugem % 16 == 14){
    digitalWrite(LED_1, HIGH);
  }else{
    digitalWrite(LED_1, LOW);
  }
}

void endBin(){
  digitalWrite(LED_1, LOW);
  digitalWrite(LED_2, LOW);
  digitalWrite(LED_3, LOW);
  digitalWrite(LED_4, LOW);
}

void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read();
    inputString += inChar;
    if((int)inChar == 1) {
      digitalWrite(LED_NET, HIGH);
      //stringComplete = true;
      internetiSeisund = 1;
    }
    else if((int)inChar == 0) {
      digitalWrite(LED_NET, LOW);
      //stringComplete = true;
      internetiSeisund = 0;
    }
  }
}
        

